#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "api.h"
#define MAXx 37 //max rozmer x pole
#define MAXy 15 //max rozmer y pole

//deklarace fce
void print_sea(SEA more);

int main(int argc, char* argv[]) {

//deklarace promennych
int x_pole, y_pole, situace;
char priznak; 					// f, x, nebo q
char retez[100];				// pro nacitani vstupu
int pom;

//malo argumentu pro spusteni programu
if (argc<3) {
  printf("Chyba parametru!\n"
  "program <x> <y> <miny> <soubor>\n"
  "x = <10, 37>, y = <10, 15>, miny = <1, x*y - 10>\n");
  return 1;
}

//spatne zadane rozmery hraciho pole, more
if (atoi(argv[1])<10||atoi(argv[1])>MAXx ||
    atoi(argv[2])<10||atoi(argv[2])>MAXy) {
  printf("Spatne rozmery hraciho pole! - %d %d\n",atoi(argv[1]),atoi(argv[2]));
  printf("Musi byt v rozpeti od 10 do 37 a pro y od 10 do 15\n");
  return 1;
}

//spatne zadany pocet min
if (atoi(argv[3])<1 || atoi(argv[3])>(atoi(argv[1])*atoi(argv[2])-10)) {
  printf("Nespravny pocet min - %d\n", atoi(argv[3]));
  return 1;
}

//prvotni vypis programu, ovladani hry
printf("--- Hra Miny ---\n");
printf("Pravidla:\n"
  ">x y   - odkryj policko na pozici x (sloupec) y (radek)\n"
  ">x y f - oznac nebo odznac policko\n"
  ">x y x - odkryj blok 3*3 policek se stredem v x y\n"
  "exit   - ukoncit program (nebo ^D)\n");

//naplneni parametru more
SEA *more = (SEA *)malloc(sizeof(SEA));
if (more==NULL) {
  printf("Chyba!!!\n"); return 1;
}
more->xs = atoi(argv[1]);
more->ys = atoi(argv[2]);
more->mines = atoi(argv[3]);
if (sea_malloc(more)==-1) {
  printf("Neporadilo se alokovat prostor pro more!\n");
  return 1;
}

//naplneni pole more
SEAFIELD napln;
napln.count = 0;
napln.mine = 0;
napln.hidden = 1;
napln.flag = 0;
sea_fill(*more, napln);

//pokud je 5 parametru, nacitame z more, jinak nahodne generujeme
if (argc==5) { 
  if (sea_load(more, argv[4])==-1) sea_randomize(*more);
}
else sea_randomize(*more);

sea_count_mines(*more);              	//spocte pro vsechna policka count
sea_hide(*more);                     	//ukryje vsechna policak v poli

do {
  print_sea(*more);                    	//vytisknuti more na zacatku spusteni
  do {                          	//cyklime dokud je vstup vadny
    x_pole = 0; y_pole = 0; priznak = 'q';
    printf("\n> ");
    if (fgets(retez, 100, stdin)==NULL) {	//pro ukonceni ^D
      printf("\n"); 
      return 0;
    }
    if (strncmp(retez, "exit", 4)==0) return 0; //koncime
    else {
      //jestli nactu EOF, taky pokracuji
      if ((pom=sscanf(retez, "%d %d %c", &x_pole, &y_pole, &priznak))==0 ||
           pom == EOF) {
        y_pole = 0; priznak = 'q';
        printf("Znovu!"); 
        continue;
      }
      if (pom==1) priznak='q';
      if (priznak!='f' && priznak!='x') priznak='q';
      retez[0] = '\0';
    }
    x_pole--; y_pole--;                 //zmenime na indexy v poli

    if (priznak=='f') {			//oflagovani
      situace = sea_flag(*more, x_pole, y_pole);
      if (situace==-3) { printf("Strilis mimo more!"); continue; }
      if (situace==-1) { printf("Policko je jiz odkryte!"); continue; }
      break;
    }
    if (priznak=='x') {			//odblokovani :)
      situace = sea_uncover_block(*more, x_pole, y_pole);
      if (situace==-3) { printf("Strilis mimo more!"); continue; }
      if (situace==1) {
        sea_uncover_mines(*more);
        print_sea(*more);
        printf("Prohral jsi!\n");
        return 0;
      }
      if (situace==2) {
        sea_flag_mines(*more);
        print_sea(*more);
        printf("Vyhral jsi!\n");
        return 0;
      }
      break;
    }
    if (priznak=='q') {			//klasika
      situace = sea_uncover(*more, x_pole, y_pole);
      if (situace==-3) { printf("Strilis mimo more!"); continue; }
      if (situace==-2) { printf("Policko je jiz oznaceno!"); continue; }
      if (situace==-1) { printf("Policko je jiz odkryto!"); continue; }
      if (situace== 1) {				//prohra
        sea_uncover_mines(*more);
    	print_sea(*more);
   	printf("Prohral jsi!\n");
    	return 0;
      }
      if (situace== 2) {				//vyhra
    	sea_flag_mines(*more);
    	print_sea(*more);
    	printf("Vyhral jsi!\n");
    	return 0;
      }
      break;
    }
  } while (1);

} while(1);

//uvolneni pameti
sea_free(more);

return 0;
}

//funkce pomocna pro vykresleni more
void print_sea(SEA more) {
  int i,j;
  printf("\n   ");
  for(i=1;i<=more.xs;i++) 
    if (i<10) printf("  "); 
    else printf("%d ",i/10);
  printf("\n   ");
  for(i=1;i<=more.xs;i++) printf("%d ", i%10);
  printf("\n  +");
  for(i=1;i<=more.xs;i++) printf("--");
  printf("+\n");
  for(i=0;i<more.ys;i++) {
    printf("%2d|", i+1);
    for(j=0;j<more.xs;j++) {
      if (more.array[i][j].flag==1) { printf("F "); continue; }
      if (more.array[i][j].hidden==1) { printf(". "); continue; }
      if (more.array[i][j].mine==1) { printf("X "); continue; }
      if (more.array[i][j].count==0) { printf("~ "); continue; }
      else printf("%d ", more.array[i][j].count);
    }
    printf("|\n");
  }
  printf("  +");
  for(i=1;i<=more.xs;i++) printf("--");
  printf("+\n");
}
